<template>
  <main>
    <mt-page-title validation>
      <h1 class="has-text-weight-bold is-size-3">Création d'une activité</h1>
    </mt-page-title>
    <form @submit.prevent="submit">
      <mt-form-fields-activity
        :activite="activite"
        :effectif-previsionnel="effectifPrevisionnel"
        :pax-max="nombrePax"
        @majEffectifPrevisionnel="majEffectifPrevisionnel"
      />
      <footer class="columns">
        <div class="column is-narrow">
          <nuxt-link :to="{ name: 'index' }">
            <b-button class="mt-button is-size-7 mt-button-fin has-text-weight-semibold" type="is-secondary" expanded>
              annuler
            </b-button>
          </nuxt-link>
        </div>
        <div class="column is-narrow">
          <b-button
            class="mt-button is-size-7 mt-button-fin has-text-weight-semibold"
            type="is-primary"
            native-type="submit"
            expanded
          >
            Créer l’activité
          </b-button>
        </div>
      </footer>
    </form>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtFormFieldsActivity from '~/components/activity/form-fields-activity';
import { creationActivite, newActivity } from '~/components/mixins/activityMixin';

export default {
  layout: 'container-small',
  components: {
    MtPageTitle,
    MtFormFieldsActivity,
  },
  mixins: [creationActivite],
  async asyncData(context) {
    const activite = newActivity(context.store);
    if (context.query['start-date'] && context.query['end-date']) {
      activite.dateDebut = new Date(context.query['start-date']);
      activite.dateFin = new Date(context.query['end-date']);
    }
    const [nombrePax, effectifPrevisionnel] = await Promise.all([
      context.$api.activites.nombreDePax(activite.organisme.id),
      context.$api.organisme().disponibilitesComplete(activite.dateDebut.toISOString(), activite.dateFin.toISOString()),
    ]);
    return {
      effectifPrevisionnel,
      activite,
      nombrePax,
    };
  },
};
</script>

<style scoped lang="scss"></style>
